//
// Copyright (C) 1999-2004 Toshikaz Hirabayashi
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// deal in the Software without restriction, including without limitation the
// rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// sell copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// TOSHIKAZ HIRABAYASHI BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
// OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.
// Except as contained in this notice, the name of Toshikaz Hirabayashi shall
// not be used in advertising or otherwise to promote the sale, use or other
// dealings in this Software without prior written authorization from
// Toshikaz Hirabayashi.

#ifndef WSDWINEXECUTE_H
#define WSDWINEXECUTE_H

#include <windows.h>
#include <WSDexecute.h>

#define WS_WIN_EXECUTE 1

class WSDwinExecute :public WSDexecute{
protected:
static void _read_thread(DWORD);
static void _check_thread(DWORD);
  char* _buffer;
  long _data_len;
  DWORD _thread_id;
  HANDLE _thread;
  HANDLE _thread2;
  HANDLE _sem;
  CRITICAL_SECTION _crs;
  HANDLE _read;
  HANDLE _write;
  HANDLE _read2;
  HANDLE _write2;
public:
  WSDwinExecute();
  virtual ~WSDwinExecute();

  virtual long killProcess();
  virtual long execute(char* name,long mode);
  virtual long read(char* ,long len);
  virtual char* gets(char* ,long len);
  virtual long write(char* ,long len);

  void _callback();

  WSMFclassDef(WSDwinExecute,WSDexecute);
};
#endif
